/******************************************************************/
//	権兵衛＆カラス
//	　　Ｉ／Ｏ別冊 ＭＺ８０活用研究よりの移植
//  X68 C版 arranged 1997,98 by AIG-Soft
//	ただしプログラムは１００％オリジナル
//  X-BASIC for iOS 版 2015 by AIG-Soft
/******************************************************************/
// for V3.20 later
// 全機種対応

str	RECHIGH="GONBE.HSC"	:/* ハイ・スコア ファイル名 */

/******************************************************************/
/* 定数＆変数定義 */

enum
	EX	=	32
	EY	=	24
	SX	=	0			/* 画面枠 */
	SY	=	0
	SSX	=	(SX+2)		/* キャラクター動作領域 */
	SSY	=	(SY+1)
	EEX	=	(EX-2)
	EEY	=	(EY-2)


	GWX=34				/* 実画面横幅 */
	WX=	GWX				/* ゲーム画面横幅 */
	WY=	25				/* ゲーム画面縦幅 */
	CX=	((GWX-WX)/2)	/* ゲーム画面を実画面の真ん中に持ってくる */
	CY=	3				/* ゲーム画面を実画面の真ん中に持ってくる */

	KEY_X	=CX+((EX-SX+1))/2
	KEY_Y	=WY+18

	FNTSZ	=	32	:// フォントサイズ

	// char範囲にすること
	JIMEN	='.'
	TANE	='*'
	KARASU	='+'
	NEMURI	='#'	/* 眠っている烏 */
	MAN		='m'
	KUSURI	='@'	/* 眠り薬 */
	// A～Z : 成長している植物
	MI	=	'i'		/* 実 */
	KABE=	'k'		/* 回りの壁 */

	HMAX	=5		// 上位何位まで記録するか(<10)
	TMAX	=1000	// 時間
	
	// キーコード:プログラム内部で生成している部分があるので変更不可
	KUP=	'8'
	KDOWN=	'2'
	KLEFT=	'4'
	KRIGHT=	'6'
	KKUSURI='5'
	EXITKEY='!'
endenum

dim char tvram(WY,WX)

int	mx,my		// 人の座標
int	fkusuri		// 眠り薬を置いているかどうか

int	kx,ky		// カラスの座標
int	fnemuri,dir,move	// 眠っているかどうか,移動方向,移動歩数

// 枠線キャラクター
str	cwaku="🏿"	://"▒"
if osVersion()<8.3 then cwaku="🌷":// 上記キャラクターはiOS8.3未満のフォントには含まれていないようだから

int	sco		// 得点
dim int	hsc(HMAX)	// 上位スコア

int	wt		// ウエイト

// ADPCM用変数
int	PCMkarasu,PCMnemuri,PCMappl,PCMtane,PCMmi,PCMbell

/******************************************************************/

// main
int ret,i,tm,j
	for i=0 to HMAX-1
		hsc(i)=0 :/* ハイスコアクリア */
	next
	int fp=fopen(RECHIGH,"r")
	if (not fopenError(fp)) then {:// hi-score write
		fread(hsc,HMAX,fp)
		fclose(fp)
	}
	
	/* 乱数初期化 */
	srand2()
	
	/* ADPCM読み込み */
	PCMappl	 =a_setPlayData("APL.PCM")
	PCMtane	 =a_setPlayData("HIQ.PCM")
	PCMmi  	 =a_setPlayData("RHIQ.PCM")
	PCMkarasu=a_setPlayData("CROW1.PCM")
	PCMnemuri=a_setPlayData("CROW2.PCM")
	PCMbell  =a_setPlayData("perc00.pcm")

	// 画面関係
	dim int	touchNo(10)	:// タッチエリア番号 / touch area number
	int touchallcnt =0	:// タッチエリア数   / the number of touch area

	// 画面初期設定
	font("HiraMinProN-W6",FNTSZ):// 等幅フォントではないので全文字１桁
//	font("Migu-1M-Regular",FNTSZ):// 先にフォントを設定してからwidth()を設定する
	int fzenhan
	width(GWX,,fzenhan,YES,,"🐓"):// ディセンダーON,基準文字変更 / descender=ON,change base character
	int xw=1:// 全角１文字の桁数 / zenkaku 1 character columus
	if fzenhan then xw=2

	repeat
		/* 初期化 */
		wt=SelectWait() // ウエイト選択
		sco=100	// 100からスタート（種を蒔くため）
		title(0)
		InitJimen()
		InitMan()
		InitKarasu()
		Setumei()	// 説明画面->スタート
		tm=TMAX
		PrTime(tm)
		j=1
		repeat /* ゲーム本体 */
			if (j=1 or j=5) then plant()
			if ((j mod 3)=0) then MoveKarasu()
			MoveMan()
			j=j+1
			if (j>=10) then j=0
			PrTime(tm)
			vwait(wt)
			tm=tm-1
		until tm<0
		
		/* ゲーム終了 */
		tColorX68(x68TYELLOW + x68HLIGHT)
		message("☆☆ ＧＡＭＥ ＯＶＥＲ ☆☆",3)
		tColorX68(x68TWHITE)
		PrHiScore(sco)
		
		dim str menues(1)
		str title$
		if isLocalizeJapan() then {
			title$="もう一度しますか？"
			menues={"はい","いいえ"}
		} else {
			title$="Try again ?"
			menues={"Yes","No"}
		}
		switch selectMenu2(title$,menues)
			case 0
				ky=0
				WaitPCM(PCMappl)
				break
			case 1
				ky=EXITKEY
				break
		endswitch
	until ky=EXITKEY
	
	// ハイスコアをファイルを書き出す
	fp=fopen(RECHIGH,"c")
	if (not fopenError(fp)) then {:// hi-score write
		fwrite(hsc,HMAX,fp)
		fclose(fp)
	}
	
	// ADPCMバッファー開放
	a_end(PCMappl)
	a_end(PCMtane)
	a_end(PCMkarasu)
	a_end(PCMnemuri)
	a_end(PCMmi)
	a_end(PCMbell)
end

/******************************************************************/

// メッセージをセンタリングで表示
func int center(y;int,mes;str)
int x
	x=(EX-SX+1-utf8Len(mes))/2 /* センタリング */
	locate(CX+x,y+CY)
	prints(mes)
	return(x)
endfunc

/* メッセージを指定回数点滅表示する */
func message(mes;str,tim;int)
int i,j,x
enum
	MSY=(SSY+(EEY-SSY)/2)
endenum
	x=CX+(EX-SX+1-utf8Len(mes))/2 /* センタリング */
	for j=SX+1 to EX-1
		locate(CX+j,MSY):prints("　")
	next
	for i=0 to tim-1
		PCMplay(PCMbell,NO)
		locate(x,MSY):prints(mes)
		WaitPCM(PCMbell)
		for j=SX+1 to EX-1
			locate(CX+j,MSY):prints("　")
		next
		vwait(5)
	next
	// 最後の音は延ばす
endfunc

/******************************************************************/

func MZ_LOCATE(x;int,y;int)
	locate(CX+x,CY+y)
endfunc

// 内部処理キャラクターと表示キャラクターの変換を行いながら表示する
func printxy(x;int,y;int,c;int)
int cc=0
	/* 仮想テキストＶＲＡＭに出力 */
	if (c>=0) then {
		if (tvram(y,x)=c) then return // 前の表示と同じなら再表示しない
	} else {
		c=-c
	}
	tvram(y,x)=c

	/* キャラクター変換 */
	// UTF文字は2バイト文字までしか正常表示できない
	str c$
	switch c
		case TANE
			c$="🌱"://"｡"
			break
		case KARASU
			c$="🐓"
			break
		case MAN
			c$="🏃"://"＄"
			break
		case MI
			c$="🍅"
			break
		case KUSURI
			c$="💊"
			break
		case NEMURI
			c$="⏰"
			break
		case KABE
			c$=cwaku
			break
		default:
			c=utf8Hantozen(c):// 全角化
			c$=utf8Chr$(c)
			break
	endswitch
	MZ_LOCATE(x,y)
	print c$;
endfunc

// MZ-80のセミグラフィックの文字はUTFの2596～259fにある
// Terminal graphic characters（端末図形文字）

/* 仮想テキストＶＲＡＭを読み出す */
func int scrn(x;int,y;int)
	return(tvram(y,x))
endfunc

/* 仮想テキストＶＲＡＭ初期化 */
func init_tvram()
int x,y
	for y=0 to WY-1
		for x=0 to WX-1
			tvram(y,x)=' '
		next
	next
endfunc

/******************************************************************/

func PrScore(sc;int)
// 得点加算＆表示
	sco=sco+sc
	locate(1,CY-1):print using "Score:%%%%%",sco
endfunc

func PrTime(tm;int)
	locate(13,CY-1):print using "Time:%%%%%",tm
endfunc

func PrRANK(rnk;int)
	locate(24,CY-1):prints("Rank:")
	if rnk>=HMAX then prints("?") else print utf8Chr$('1'+rnk)
endfunc

/******************************************************************/

// 初期画面作成
func title(mode;int)
int x,y
	// 画面クリア
	if (not mode) then {
		cls()
		init_tvram()
	}
	
	tColorX68(x68TCYAN+x68HLIGHT+x68REVERSE)
	center(-2,"＊＊　権兵衛＆カラス　＊＊")
	tColorX68(x68TWHITE)
	
//	MZ_LOCATE(EX+1, 0):prints("＊＊＊＊＊＊＊")
//	MZ_LOCATE(EX+1, 1):prints("　権兵衛")
//	MZ_LOCATE(EX+1, 2):prints("　 　＆")
//	MZ_LOCATE(EX+1, 3):prints("　 　 カラス")
//	MZ_LOCATE(EX+1, 4):prints("＊＊＊＊＊＊＊")
//	MZ_LOCATE(EX+1,14):prints("＃＃＃＃＃＃＃")

	printKeys(KEY_X,KEY_Y)
	
	PrScore(0)
	PrRANK(HMAX)
	PrTime(0)
	
	for y=SY to EY // 縦壁
		printxy(SX,y,KABE)
		printxy(EX,y,KABE)
	next
	for x=SX+1 to EX-1 // 横壁
		printxy(x,SY,KABE)
		printxy(x,EY,KABE)
	next
endfunc

func InitJimen()
// 地面の初期化
int x,y
	for y=SY+2 to EY-1
		for x=SSX to EEX
			printxy(x,y,JIMEN)
			x=x+1
		next
		y=y+1
	next
endfunc

/******************************************************************/

func plant()
// 植物を育てる・枯らす
int x,y,c,cc
	for y=SY+2 to EY
		for x=SSX to EEX
			//if (x=mx and y=my+1) then continue // 蒔いた直後の種は育たない
			int fend=NO
			cc=0
			// 次のキャラクターの設定
			c=scrn(x,y)
			switch (c)
				case TANE:cc='A':break // 種が発芽
				case 'Z' :cc=MI :break // 植物の成長
				case MI  :cc=JIMEN // 実の後は枯れるだけ
					if (rand2(100)>20) then fend=YES // 枯れない
					break
				default:
					if (c>='A' and c<='Z'-1) then cc=c+1
					break
			endswitch
			if (fend) then continue
			if (cc<>0) then { // 変化する時
				c=rand2(100)
				if (c<1) then {
					printxy(x,y,JIMEN) // 枯れた
				} else {
					if (c>=35) then printxy(x,y,cc)  // 育った
				}
				// else 育たない
			}
			x=x+1
		next
		y=y+1
	next
endfunc

/******************************************************************/

func int SetHosuu()
// カラスの移動歩数を設定する
	return(3+rand2(3))
endfunc

func InitKarasu()
// カラスの初期状態設定
	kx=EX-2
	ky=SY+1 // カラスの初期座標
	printxy(kx,ky,KARASU)
	move=SetHosuu()
	dir=KDOWN+rand2(2)*2 // 移動方向最初はKDOWNまたはKLEFTのみ
	fnemuri=0
endfunc

func MoveKarasu()
// カラスの移動
int c,x,y,cc
	if (fnemuri>0) then {
		// 眠っている
		fnemuri=fnemuri-1
		return
	}
	move=move-1
	if (move=0) then { // 移動方向変更
		move=SetHosuu() // 移動歩数
		dir=KDOWN+rand2(4)*2 // 移動方向:KDOWNKLEFTKRIGHTKUP
	}
	x=kx
	y=ky
	switch (dir)
		case KUP: // 上
			if (y>SSY  ) then y=y-2
			break
		case KDOWN: // 下
			if (y<EEY-1) then y=y+2 // 一番下の地面の上まで
			break
		case KRIGHT: // 右
			if (x<EEX  ) then x=x+2
			break
		case KLEFT: // 左
			if (x>SSX  ) then x=x-2
			break
	endswitch:// 移動しないときもある
	if (scrn(x,y)=MAN) then return // 移動先に人がいる : 動けない
	if (kx<>x or ky<>y) then printxy(kx,ky,' ')
	kx=x
	ky=y
	cc=KARASU
	c=scrn(x,y+1) // 移動先の地面は何？
	switch (c)
	    case KUSURI: // 眠り薬を食べた
			PCMplay(PCMnemuri,NO)
			cc=NEMURI
			fnemuri=20+rand2(5)  // 眠っている時間
			printxy(x,y+1,JIMEN) // 薬を消す
			fkusuri=0
			break
//	    default:
//			if (c<'A' or c>'Z') then break
//			// 種、植物、実を食べた
	    case TANE:
	    case MI:
			PCMplay(PCMkarasu,NO)
			printxy(x,y+1,JIMEN)
			break
	    //実は最下行ではKABEになる
		default:
			if (c<'A' or c>'Z') then break
			// 種、植物、実を食べた
			PCMplay(PCMkarasu,NO)
			printxy(x,y+1,JIMEN)
			break
	endswitch
//	WaitPCM() <- PCM8対応のためコメントにする
	printxy(x,y,cc)
endfunc

/******************************************************************/

func InitMan()
// 人の初期座標
	mx=SSX
	my=SSY
	printxy(mx,my,MAN)
	fkusuri=0 // 眠り薬は置いてない
endfunc

// 人の移動
func MoveMan()
int x,y,fm=0
	x=mx
	y=my
	switch (inkey())
		case KKUSURI: // 眠り薬
			if (fkusuri or sco<10) then {
				beep() // 薬は置けない
			} else {
				PCMplay(PCMtane,NO)
				PrScore(-10)
				printxy(x,y+1,KUSURI)
				//WaitPCM() PCM8対応のため
				fkusuri=1
			}
			return
		case KUP: // 上
			if (y>SSY  ) then y=y-2
			break
		case KDOWN: // 下
			if (y<EEY-1) then y=y+2 // 一番下の地面の上まで
			break
		case KRIGHT: // 右
			if (x<EEX  ) then x=x+2
			break
		case KLEFT: // 左
			if (x>SSX  ) then x=x-2
			break
	endswitch
	kbclr()

	// 移動先は何？
	switch (scrn(x,y))
		case NEMURI:
		case KARASU:
			return // カラス->移動できない
	endswitch
	if (mx<>x or my<>y) then {
		printxy(mx,my,' ')
		fm=1 // 移動した
	}
	mx=x
	my=y
	printxy(x,y,MAN)
	switch (scrn(x,y+1)) // 地面は何？（移動してない時もあり）
	    case KUSURI:// 眠り薬 -> 拾う
			if (fm) then { // 移動した時のみ
				PCMplay(PCMmi,NO)
				printxy(x,y+1,JIMEN) // 薬を消す
				fkusuri=0
			}
			break
	    case JIMEN: // 地面
			if (sco>0) then {
				// 歩くときに種を蒔く
				PCMplay(PCMtane,NO)
				PrScore(-1)
				printxy(x,y+1,TANE)
			} // ０点以下の時は種を蒔けない
			break
	    case MI: // 実
			PCMplay(PCMmi,NO)
			PrScore(50)
			printxy(x,y+1,JIMEN)
			break
		    //実は最下行ではKABEになる
	endswitch
//	WaitPCM() <- PCM8対応のためコメントにする
endfunc

/******************************************************************/

// 現在のハイスコア表示
func NowHiScore(y;int,r;int)
int x,i
	tColorX68(x68TYELLOW+x68HLIGHT+x68REVERSE)
	x=center(y,"ＨＩ－ＳＣＯＲＥ")
	for i=0 to HMAX-1
		int col=x68TWHITE
		if i=r then col=x68TCYAN+x68REVERSE
		tColorX68(col)
		locate(CX+x,CY+y+2+i)
		print utf8Chr$('１'+i);"  ";
		print using "%%%%%",hsc(i)
		tColorX68(x68TWHITE)
	next
endfunc

// 上位記録を表示（ランクイン判定付き）
func int PrHiScore(h;int)
int i,j,r=HMAX
	// ハイスコアは(0)>>...>>(4)の順に並んでいる
	// 今回のスコアがどこに入るか
	for i=0 to HMAX-1
		if (h>hsc(i)) then { // 後のものを入れ換える
			j=HMAX-1
			while j>i
				hsc(j)=hsc(j-1)
				j=j-1
			endwhile
			hsc(i)=h
			r=i
			break
		}
	next
	// 表示
	if (r=0) then PCMplay(PCMappl,NO) // 第１位
	NowHiScore(5,r)
	PrRANK(r)
	// 0なら最上位、HMAXならランク外
	WaitPCM(PCMappl)
	return(i)
endfunc

/******************************************************************/

// ウエイト選択
func int SelectWait()
int wt
	cls()
	dim str menues(4)
	str title$
	if isLocalizeJapan() then {
		title$="ゲーム スピード 選択"
		menues={"ゆっくり","普通","速い","暴走！！"}
	} else {
		title$="Select game speed"
		menues={"Slow","Normal","Fast","Very Fast"}
	}
	wt=0
	switch selectMenu2(title$,menues)
		case 0:wt=18 :break
		case 1:wt=13 :break
		case 2:wt=8  :break
		case 3:wt=4  :break
	endswitch
	return(wt)
endfunc

// 説明画面・・・のはずだったけど面倒なのでスタート画面にする
func Setumei()
enum
	MSX=((EX-SX)/2-8/2)
endenum
int tm
int PCMp1,PCMp2
	PCMp1=a_setPlayData("PREL_C5.PCM")
	PCMp2=a_setPlayData("PREL_C6.PCM")
	wait(1)
	for tm=0 to 2
		MZ_LOCATE(MSX,EY+1):print "開始 ";utf8Chr$('０'+3-tm);"秒前"
		PCMplay(PCMp1,NO)
		wait(1.0)
		WaitPCM(PCMp1)
	next
	MZ_LOCATE(MSX,EY+1):prints("開始！！　　")
	PCMplay(PCMp2,YES)
	MZ_LOCATE(MSX,EY+1):prints("　　　　　　")
	WaitPCM(PCMp2)
	a_end(PCMp1)
	a_end(PCMp2)
endfunc

/******************************************************************/

func printKeys(x;int,y;int)
	enum
		XC=3
		YC=3
	endenum
	int K1X=16*4,K1Y=16*4
	x=x*16
	y=y*16
	str dev=devicePlatform()
	if (left$(dev,4)<>"iPad") then {
		K1X=16*2
		K1Y=16*2
		x=x/3
		y=y/2-(y/14)
	}
	if touchallcnt =0 then {
		vpriority(TPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
		vpage(B_TPAGE+B_GPAGE0+B_GPAGE1+B_GPAGE2+B_GPAGE3)
		apage(GPAGE0)
		dim int keys( XC*YC-1)={0,KUP,0,KLEFT,KKUSURI+FKEY_NOT_REPEAT,KRIGHT,0,KDOWN,0}
		dim str disps(XC*YC-1)={" ","↑"," ","←","薬","→"," ","↓"," "}
		touchallcnt =setTouchKeys(x,y,XC,YC,K1X,K1Y,keys,disps,"Migu-1M-Regular",touchNo)
	}
endfunc

func removeKeys()
// 全タッチアリアの解除 / reset all key touch area
	resetAllTouchKeys(touchNo,touchallcnt)
	touchallcnt =0:// 登録してないの印
endfunc
